import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { HouseLikeLog, HouseLikeLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询房源点赞表
 */
export async function pageHouseLikeLog(params: HouseLikeLogParam) {
  const res = await request.get<ApiResult<PageResult<HouseLikeLog>>>(
    MODULES_API_URL + '/house/house-like-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询房源点赞表列表
 */
export async function listHouseLikeLog(params?: HouseLikeLogParam) {
  const res = await request.get<ApiResult<HouseLikeLog[]>>(
    MODULES_API_URL + '/house/house-like-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加房源点赞表
 */
export async function addHouseLikeLog(data: HouseLikeLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-like-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改房源点赞表
 */
export async function updateHouseLikeLog(data: HouseLikeLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-like-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除房源点赞表
 */
export async function removeHouseLikeLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-like-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除房源点赞表
 */
export async function removeBatchHouseLikeLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-like-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询房源点赞表
 */
export async function getHouseLikeLog(id: number) {
  const res = await request.get<ApiResult<HouseLikeLog>>(
    MODULES_API_URL + '/house/house-like-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
